/*                                                           01-03-96 16:33pm
 ****************************************************************************
 * AVL NetWare C Interface Library     Version 1.02.002      01-02-96 02:54pm
 ****************************************************************************
 *
 *   GETCURFS.C       Gets Current FileServer Name
 *
 *   Prototype:
 *            char *NetWare_getCurFSName( void );
 *
 ****************************************************************************
 *
 * Copyright (c) 1995,1996 Alexander V. Loukyanets
 * All rights reserved.
 *
 ****************************************************************************
 *
 * Compiler :  Zortech C/C++ 3.1r2 (Patched)
 *
 ****************************************************************************
 */

#include    <string.h>
#if defined( DEBUGGING )
#include    <stdio.h>
#endif
#include    <dos.h>
#include    "netware.h"


#pragma ZTC align 1


/*
 ****************************************************************************
 */

char *NetWare_getCurFSName( void )
{
  int                       conID;
  register int              i;
  netware_servers_table_pt  servers;

  NetWare_getServersTable( &servers );
  conID=NetWare_getDefaultConID();
  if ( conID < 1 || conID > 8 ) {
    conID=NetWare_getPrimaryConID();
    if ( conID < 1 || conID > 8 ) conID=NetWare_getPreferredConID();
  }

  if ( conID < 1 || conID > 8 ) return( NULL );
  else           return( (*servers)[conID-1] );
}



#pragma ZTC align

/****************************************************************************
*** end of GETCURFS.C ***/
