/*                                                           12-23-95 04:43pm
 ****************************************************************************
 * AVL NetWare C Interface Library     Version 1.02.002      01-02-96 02:54pm
 ****************************************************************************
 *
 *   GETVERS.C        Gets the NetWare WorkStation Shell Version Information
 *
 *   Prototype:
 *            int NetWare_getShellVersion( int *piVerMajor, int *piVerMinor,
 *                                         int *piRevision, char **bptr );
 *
 *   Usage:
 *            int   VMaj, VMin, VRev;
 *            char *str;
 *            NetWare_getShellVersion( &VMaj, &VMin, &VRev, &str );
 *
 ****************************************************************************
 *
 * Copyright (c) 1995,1996 Alexander V. Loukyanets
 * All rights reserved.
 *
 ****************************************************************************
 *
 * Compiler :  Zortech C/C++ 3.1r2 (Patched)
 *
 ****************************************************************************
 */

#include    "libvers.h"

#include    <string.h>
#if defined( DEBUGGING )
#include    <stdio.h>
#endif
#include    <dos.h>
#include    "netware.h"


const char *netware_Copyright="\n"_AVLNETWARE_ProdName" "_AVLNETWARE_VersNumb"("_AVLNETWARE_VersDate")"
"\nCopyright (c) 1995,1996 Alexander V. Loukyanets.  ALL RIGHTS RESERVED.";


#pragma ZTC align 1


/*
 ****************************************************************************
 */

int NetWare_getShellVersion( int *piVerMajor, int *piVerMinor, int *piRevision, char **bptr )
{
  union   REGS      regs;
  struct SREGS      segregs;
  static char       buffer[50];
  int               ret;

  memset( buffer, 0, sizeof(buffer) );
  regs.x.ax = 0xea01;
  regs.x.bx = 0;
  segregs.es = FP_SEG((void _far *)buffer);
  regs.x.di  = FP_OFF((void _far *)buffer);
  int86x( 0x21, &regs, &regs, &segregs );
  ret = regs.x.bx;
  *piVerMajor = (int)regs.h.bh;
  *piVerMinor = (int)regs.h.bl;
  *piRevision = (int)regs.h.cl;
  buffer[49] = '\0';
  (*bptr) = buffer;

  return( ret );  // 0 -- NO NetWare
}



#pragma ZTC align

/****************************************************************************
*** end of GETVERS.C ***/
