/*                                                           12-23-95 04:43pm
 ****************************************************************************
 * AVL NetWare C Interface Library     Version 1.02.002      01-02-96 02:54pm
 ****************************************************************************
 *
 *   GETVOLNA.C       Gets Volume Name by Volume Number
 *
 *   Prototype:
 *            int NetWare_getVolumeName( int VolNumber, char *VolName );
 *
 ****************************************************************************
 *
 * Copyright (c) 1995,1996 Alexander V. Loukyanets
 * All rights reserved.
 *
 ****************************************************************************
 *
 * Compiler :  Zortech C/C++ 3.1r2 (Patched)
 *
 ****************************************************************************
 */

#include    <string.h>
#if defined( DEBUGGING )
#include    <stdio.h>
#endif
#include    <dos.h>
#include    "netware.h"


#pragma ZTC align 1


/*
 ****************************************************************************
 */

int NetWare_getVolumeName( int VolNumber, char *VolName )
{
  struct SREGS    segregs;
  union  REGS     regs;
  struct request_ {
    UWORD     buffer_length;
    UBYTE     request_type;
    UBYTE     volume_number;
  }               buf_request;
  struct reply_ {
    UWORD     buffer_length;
    UBYTE     volume_nameLength;
    UBYTE     volume_name[16];
  }               buf_reply;

  buf_request.buffer_length = sizeof( struct request_ ) - 2;
  buf_reply.buffer_length   = sizeof( struct reply_ ) - 2;

  buf_request.request_type  = 0x06;
  buf_request.volume_number = VolNumber;

  regs.h.ah   = 0xE2;
  segregs.ds  = FP_SEG( (void _far *)&buf_request );
  regs.x.si   = FP_OFF( (void _far *)&buf_request );
  segregs.es  = FP_SEG( (void _far *)&buf_reply );
  regs.x.di   = FP_OFF( (void _far *)&buf_reply );
  int86x( 0x21, &regs, &regs, &segregs );

  if ( buf_reply.volume_nameLength > 0 )
    memcpy( VolName, buf_reply.volume_name, 16 );

  VolName[ buf_reply.volume_nameLength ] = '\0';

  return( regs.h.al ); // 0 if OK
}



#pragma ZTC align

/****************************************************************************
*** end of GETVOLNA.C ***/
