/*                                                           01-02-96 04:24pm
 ****************************************************************************
 * AVL NetWare C Interface Library     Version 1.02.002      01-02-96 02:54pm
 ****************************************************************************
 *
 *   NETWARE.H        Public Header file for AVL NetWare C Interface Library.
 *
 * Copyright (c) 1995,1996 Alexander V. Loukyanets
 * All rights reserved.
 *
 ****************************************************************************
 *
 * Compiler :  Zortech C/C++ 3.1r2 (Patched)
 *
 ****************************************************************************
 */


#pragma ZTC align 1


/*
 ****************************************************************************
 *  Constants Definitions
 */

//============================================== Return Codes

#define   NETW_OK               0

//----------------------- Attach RetCodes ( NetWare_AttachToFS(..) )
#define   NETW_AT_ALREADYATT    0xf8  // Already attached
#define   NETW_AT_NOFREEWSSC    0xf9  // No free WorkStation socket
#define   NETW_AT_NOFREEFSSC    0xfa  // No free FileServer socket
#define   NETW_AT_UNKNOWN_FS    0xfc  // Unknown FS
#define   NETW_AT_BINDLOCKED    0xfe  // Bindary locked
#define   NETW_AT_NOANSWERFS    0xff  // No answer from FS

//----------------------- Detach RetCodes ( NetWare_DetachFromFS(..) )
#define   NETW_DT_NOCONNECTD    0xff  // No connection

//----------------------- Directory Functions RetCodes
#define   NETW_DF_NONETVOLUME   0x98  // Net Volume not exist
#define   NETW_DF_BADDIRHANDLE  0x9b  // Bad Directory handle
#define   NETW_DF_INVALIDPATH   0x9c  // Invalid path
#define   NETW_DF_PATHNOTLOCAT  0xff  // Path not locatable

/***************************************************/
#define FILE_IN_USE_ERROR					0x80	/* 128 */
#define NO_MORE_FILE_HANDLES				0x81	/* 129 */
#define NO_OPEN_PRIVILEGES					0x82	/* 130 */
#define IO_ERROR_NETWORK_DISK				0x83	/* 131 */
#define NO_CREATE_PRIVILEGES				0x84	/* 132 */
#define NO_CREATE_DELETE_PRIVILEGES			0x85	/* 133 */
#define CREATE_FILE_EXISTS_READ_ONLY		0x86	/* 134 */
#define WILD_CARDS_IN_CREATE_FILE_NAME		0x87	/* 135 */
#define INVALID_FILE_HANDLE					0x88	/* 136 */
#define NO_SEARCH_PRIVILEGES				0x89	/* 137 */
#define NO_DELETE_PRIVILEGES				0x8a	/* 138 */
#define NO_RENAME_PRIVILEGES				0x8b	/* 139 */
#define NO_MODIFY_PRIVILEGES				0x8c	/* 140 */
#define SOME_FILES_AFFECTED_IN_USE			0x8d	/* 141 */
#define NO_FILES_AFFECTED_IN_USE			0x8e	/* 142 */
#define SOME_FILES_AFFECTED_READ_ONLY		0x8f	/* 143 */
#define NO_FILES_AFFECTED_READ_ONLY			0x90	/* 144 */
#define SOME_FILES_RENAMED_NAME_EXISTS		0x91	/* 145 */
#define NO_FILES_RENAMED_NAME_EXISTS		0x92	/* 146 */
#define NO_READ_PRIVILEGES					0x93	/* 147 */
#define NO_WRITE_PRIVILEGES_OR_READONLY		0x94	/* 148 */
#define FILE_DETACHED						0x95	/* 149 */
#define SERVER_OUT_OF_MEMORY				0x96	/* 150 */
#define NO_DISK_SPACE_FOR_SPOOL_FILE		0x97	/* 151 */
#define VOLUME_DOES_NOT_EXIST				0x98	/* 152 */
#define DIRECTORY_FULL						0x99	/* 153 */
#define RENAMING_ACROSS_VOLUMES				0x9a	/* 154 */
#define BAD_DIRECTORY_HANDLE				0x9b	/* 155 */
#define INVALID_PATH						0x9c	/* 156 */
#define NO_MORE_TRUSTEES					0x9c
#define NO_MORE_DIRECTORY_HANDLES			0x9d	/* 157 */
#define INVALID_FILENAME					0x9e	/* 158 */
#define DIRECTORY_ACTIVE					0x9f	/* 159 */
#define DIRECTORY_NOT_EMPTY					0xa0	/* 160 */
#define DIRECTORY_IO_ERROR					0xa1	/* 161 */
#define READ_FILE_WITH_RECORD_LOCKED		0xa2	/* 162 */
#define LOGIN_DENIED_NO_ACCOUNT_BALANCE		0xc1	/* 193 */
#define LOGIN_DENIED_NO_CREDIT				0xc2	/* 194 */
#define INTRUDER_DETECTION_LOCK				0xc5	/* 197 */
#define PASSWORD_NOT_UNIQUE					0xd7	/* 215 */
#define PASSWORD_TOO_SHORT					0xd8	/* 216 */
#define LOGIN_DENIED_NO_CONNECTION			0xd9	/* 217 */
#define UNAUTHORIZED_LOGIN_TIME				0xda	/* 218 */
#define UNAUTHORIZED_LOGIN_STATION			0xdb	/* 219 */
#define ACCOUNT_DISABLED					0xdc	/* 220 */
#define PASSWORD_HAS_EXPIRED_NO_GRACE		0xde	/* 222 */
#define PASSWORD_HAS_EXPIRED				0xdf	/* 223 */
#define NOT_ITEM_PROPERTY					0xe8	/* 232 */
#define WRITE_PROPERTY_TO_QROUP				0xe8
#define MEMBER_ALREADY_EXISTS				0xe9	/* 233 */
#define NO_SUCH_MEMBER						0xea	/* 234 */
#define NOT_GROUP_PROPERTY					0xeb	/* 235 */
#define NO_SUCH_SEGMENT						0xec	/* 236 */
#define PROPERTY_ALREADY_EXISTS				0xed	/* 237 */
#define OBJECT_ALREADY_EXISTS				0xee	/* 238 */
#define INVALID_NAME						0xef	/* 239 */
#define WILD_CARD_NOT_ALLOWED				0xf0	/* 240 */
#define IPX_NOT_INSTALLED					0xf0
#define INVALID_BINDERY_SECURITY			0xf1	/* 241 */
#define NO_OBJECT_READ_PRIVILEGE			0xf2	/* 242 */
#define NO_OBJECT_RENAME_PRIVILEGE			0xf3	/* 243 */
#define NO_OBJECT_DELETE_PRIVILEGE			0xf4	/* 244 */
#define NO_OBJECT_CREATE_PRIVILEGE			0xf5	/* 245 */
#define NO_PROPERTY_DELETE_PRIVILEGE		0xf6	/* 246 */
#define NOT_SAME_LOCAL_DRIVE 				0xf6
#define NO_PROPERTY_CREATE_PRIVILEGE		0xf7	/* 247 */
#define TARGET_DRIVE_NOT_LOCAL				0xf7
#define ALREADY_ATTACHED_TO_SERVER			0xf8	/* 248 */
#define NO_PROPERTY_WRITE_PRIVILEGE			0xf8
#define NOT_ATTACHED_TO_SERVER				0xf8
#define NO_FREE_CONNECTION_SLOTS			0xf9	/* 249 */
#define NO_PROPERTY_READ_PRIVILEGE			0xf9
#define NO_MORE_SERVER_SLOTS				0xfa	/* 250 */
#define TEMP_REMAP_ERROR					0xfa
#define INVALID_PARAMETERS					0xfb	/* 251 */
#define NO_SUCH_PROPERTY					0xfb
#define UNKNOWN_REQUESE						0xfb
#define INTERNET_PACKET_REQT_CANCELED		0xfc	/* 252 */
#define UNKNOWN_FILE_SERVER					0xfc
#define MESSAGE_QUEUE_FULL					0xfc
#define NO_SUCH_OBJECT						0xfc
#define BAD_STATION_NUMBER					0xfd	/* 253 */
#define INVALID_PACKET_LENGTH				0xfd
#define UNKNOWN_REQUEST						0xfd
#define FIELD_ALREADY_LOCKED				0xfd
#define BINDERY_LOCKED						0xfe	/* 254 */
#define DIRECTORY_LOCKED					0xfe
#define INVALID_SEMAPHORE_NAME_LENGTH		0xfe
#define PACKET_NOT_DELIVERABLE				0xfe
#define SERVER_BINDERY_LOCKED				0xfe
#define SOCKET_TABLE_FULL					0xfe
#define SPOOL_DIRECTORY_ERROR				0xfe
#define SUPERVISOR_HAS_DISABLED_LOGIN		0xfe
#define TIMEOUT_FAILURE						0xfe
#define BAD_PRINTER_ERROR					0xff	/* 255 */
#define BAD_RECORD_OFFSET					0xff
#define CLOSE_FCB_ERROR						0xff
#define FILE_EXTENSION_ERROR				0xff
#define FILE_NAME_ERROR						0xff
#define HARDWARE_FAILURE					0xff
#define INVALID_DRIVE_NUMBER				0xff
#define INVALID_INITIAL_SEMAPHORE_VALUE		0xff
#define INVALID_SEMAPHORE_HANDLE			0xff
#define IO_BOUND_ERROR						0xff
#define NO_FILES_FOUND_ERROR				0xff
#define NO_RESPONSE_FROM_SERVER				0xff
#define NO_SUCH_OBJECT_OR_BAD_PASSWORD		0xff
#define PATH_NOT_LOCATABLE					0xff
#define QUEUE_FULL_ERROR					0xff
#define REQUEST_NOT_OUTSTANDING				0xff
#define SOCKET_ALREADY_OPEN					0xff
#define NO_CONSOLE_OPERATOR					0xc6
/***************************************************/


//============================================== General Constants

#define   NETW_MAXN_FS          8

//----------------------- Drive Flag Table Codes ( NetWare_getDriveFlagTable(..) )
#define   NETW_DFL_NO_DRIVE     0x00  // This drive not present
#define   NETW_DFL_PERMNETDRV   0x01  // This is permanent net drive
#define   NETW_DFL_TEMPNETDRV   0x02  // This is temperate net drive
#define   NETW_DFL_LOCALDRIVE   0x80  // This is local drive
#define   NETW_DFL_PERMLOCDRV   0x81  // This is local drive permanently maped upon net directory
#define   NETW_DFL_TEMPLOCDRV   0x82  // This is local drive temperately maped upon net directory


/*
 ****************************************************************************
 *  Types Definitions
 */

typedef enum {
  NETW_OBJ_UNKNOWN    = 0x0000,       // Unknown object
  NETW_OBJ_USER       = 0x0100,       // User
  NETW_OBJ_UGROUP     = 0x0200,       // Users Group
  NETW_OBJ_PRNQ       = 0x0300,       // Print Queue
  NETW_OBJ_FILSERVER  = 0x0400,       // File Server
  NETW_OBJ_APPSERVER  = 0x0500,       // Application Server
  NETW_OBJ_GATEWAY    = 0x0600,       // Gateway
  NETW_OBJ_PRNSERVER  = 0x0700,       // Print Server
  NETW_OBJ_ARCQ       = 0x0800,       // Archive Queue
  NETW_OBJ_ARCSERVER  = 0x0900,       // Archive Server
  NETW_OBJ_JOBQ       = 0x0a00,       // Job Queue
  NETW_OBJ_ADMIN      = 0x0b00,       // Admin
  NETW_OBJ_NASSNAGW   = 0x2100,       // NAS SNA Gateway
  NETW_OBJ_BRDSERVER  = 0x2600,       // Remote Bridge Server
  NETW_OBJ_TCPIPGW    = 0x2700,       // TCP/IP Gateway
  NETW_OBJ_WILD       = 0xffff        // MATCHES ANY TYPE
}               netware_objtype_t;

typedef unsigned char   UBYTE;     // 1 byte
typedef unsigned short  UWORD;     // 2 bytes
typedef unsigned long   UDBLWORD;  // 4 bytes

typedef char    netware_namestring_t [48];

typedef struct _netware_info_request_t_ {
  UWORD                 request_length;
  UBYTE                 subfunction;
  UBYTE                 buffer_connect_num;
}               netware_info_request_t;

typedef struct _netware_coninfo_t_ {
  UWORD                 reply_length;
  UDBLWORD              object_id;
  UWORD                 object_type;
  netware_namestring_t  object_name;
  UBYTE                 login_time [7];
}               netware_coninfo_t;

typedef struct _netware_intnetadr_t_ {
  UWORD                 buffer_length;
  UDBLWORD              network_number;
  UBYTE                 node_address[6];
  UWORD                 socket_number;
}               netware_intnetadr_t;

typedef struct _netware_objrequest_t_ {
  UWORD                 buffer_length;
  UBYTE                 request_type;
  UDBLWORD              last_object_id;
  UWORD                 object_type;
  UBYTE                 name_length;
  netware_namestring_t  object_name;
}               netware_objrequest_t;

typedef struct _netware_objreply_t_ {
  UWORD                 buffer_length;
  UDBLWORD              object_id;
  UWORD                 object_type;
  netware_namestring_t  object_name;
  UBYTE                 object_flag;
  UBYTE                 object_security;
  UBYTE                 object_has_properties;
}               netware_objreply_t;

typedef struct _netware_proprequest_t_ {
  UWORD                 buffer_length;
  UBYTE                 request_type;
  UWORD                 object_type;
  UBYTE                 object_name_length;
  netware_namestring_t  object_name;
  UDBLWORD              sequence_number;
  UBYTE                 property_name_length;
  char                  property_name[16];
}               netware_proprequest_t;

typedef struct _netware_propreply_t_ {
  UWORD                 buffer_length;
  char                  property_name[16];
  UBYTE                 property_flags;
  UBYTE                 property_security;
  UDBLWORD              sequence_number;
  UBYTE                 property_has_value;
  UBYTE                 more_properties;
}               netware_propreply_t;

typedef struct _netware_valrequest_t_ {
  UWORD                 buffer_length;
  UBYTE                 request_type;
  UWORD                 object_type;
  UBYTE                 object_name_length;
  netware_namestring_t  object_name;
  UBYTE                 segment_number;
  UBYTE                 property_name_length;
  char                  property_name[16];
}               netware_valrequest_t;

typedef struct _netware_valreply_t_ {
  UWORD                 buffer_length;
  char                  property_value[128];
  UBYTE                 more_segments;
  UBYTE                 property_flags;
}               netware_valreply_t;

typedef struct _netware_connect_table_area_t_ {
  UBYTE                 in_use_flag;
  UBYTE                 order_number;
  UDBLWORD              network_number;
  UBYTE                 node_address[6];
  UWORD                 socket_number;
  UWORD                 receive_timeout;
  UBYTE                 routing_node[6];
  UBYTE                 packet_sequence_number;
  UBYTE                 connection_number;
  UBYTE                 connection_status;
  UWORD                 maximum_timeout;
  UBYTE                 reserved[5];
}               netware_connect_table_area_t [NETW_MAXN_FS];

typedef netware_namestring_t
                netware_servers_table_area_t [NETW_MAXN_FS];

typedef UBYTE   netware_drive_table_area_t   [32];

typedef netware_connect_table_area_t _far *
                netware_connect_table_pt;

typedef netware_servers_table_area_t _far *
                netware_servers_table_pt;

typedef netware_drive_table_area_t _far *
                netware_drive_table_pt;

#pragma ZTC align


/*
 ****************************************************************************
 *  Prototypes Definitions
 */

void (_far *ipxspx_entry)               ( void );
int         NetWare_Is_ipx_Installed    ( void );
int         NetWare_getShellVersion     ( int *piVerMajor, int *piVerMinor,
                                          int *piRevision, char **bptr );
int         NetWare_getCPUname          ( char **cpu_name );
void        NetWare_getDriveHandleTable ( netware_drive_table_pt   _far *TabAddr );
void        NetWare_getDriveFlagTable   ( netware_drive_table_pt   _far *TabAddr );
void        NetWare_getDriveConnectTable( netware_drive_table_pt   _far *TabAddr );
void        NetWare_getConnectTable     ( netware_connect_table_pt _far *connections );
void        NetWare_getServersTable     ( netware_servers_table_pt _far *servers );
char       *NetWare_getCurFSName        ( void );
int         NetWare_getConNumber        ( void );
int         NetWare_getConInfo          ( netware_coninfo_t     *reply_buffer );
int         NetWare_getObjectConInfo    ( int connect_number,
                                          netware_coninfo_t     *reply_buffer );
int         NetWare_getIntnetAdr        ( netware_intnetadr_t   *reply_buffer );
int         NetWare_getObjectIntnetAdr  ( int connect_number,
                                          netware_intnetadr_t   *reply_buffer );
int         NetWare_AttachToFS          ( UBYTE ConID );
int         NetWare_DetachFromFS        ( UBYTE ConID );
int         NetWare_getPrimaryConID     ( void );
int         NetWare_getDefaultConID     ( void );
int         NetWare_getPreferredConID   ( void );
int         NetWare_SetPrimaryConID     ( UBYTE ConID );
int         NetWare_SetPreferredConID   ( UBYTE ConID );
int         NetWare_getVolumeName       ( int VolNumber, char *VolName );
int         NetWare_getVolumeNumber     ( char *VolName, int *VolNumber );
int         NetWare_getVolumeInfo       ( int VolNumber, char *VolName,
                                          UWORD *TotalBlocks, UWORD *SectorsPerBlock,
                                          UWORD *AvailBlocks, UWORD *TotalDirSlots,
                                          UWORD *AvailDirSlots, UWORD *Removable );
int         NetWare_ScanDirInfo         ( UBYTE DirHandle, char *SearchDirPath,
                                          int *SequenceNumber, char *DirName,
                                          UBYTE *CreaDateTime, UDBLWORD *OwnerObjID,
                                          UBYTE *MaxRightMask );
int         NetWare_init_scan_object    ( void );
int         NetWare_init_scan_property  ( void );
int         NetWare_init_scan_value     ( void );
int         NetWare_get_next_object     ( netware_objrequest_t  *object_request,
                                          netware_objreply_t    *object_reply );
int         NetWare_get_next_property   ( netware_proprequest_t *property_request,
                                          netware_propreply_t   *property_reply,
                                          netware_objreply_t    *object_reply );
int         NetWare_get_value           ( netware_valrequest_t  *value_request,
                                          netware_valreply_t    *value_reply,
                                          netware_propreply_t   *property_reply,
                                          netware_objreply_t    *object_reply );
int         Is_It_Remote_Drive          ( UWORD drv );
int         Is_It_Remote_Handle         ( int filehandle );


/****************************************************************************
*** end of NETWARE.H ***/
